<?php
/*
Plugin Name: VarkTech Wholesale Pricing PRO for WooCommerce
Plugin URI: http://varktech.com
Description: An e-commerce add-on for WooCommerce, supplying Wholesale Pricing functionality.
Version: 1.0.61
Author: VarkTech
Author URI: http://varktech.com
WC requires at least: 2.4.0
WC tested up to: 3.2.0
*/

   
   //initial setup only, overriden later in function vwpr_debug_options
   error_reporting(E_ERROR | E_CORE_ERROR | E_COMPILE_ERROR); //1.0.3
    
      
class VTWPR_Pro_Controller{
	
	public function __construct(){    
    global $wpdb;
    add_action('init', array( &$this, 'vtwpr_pro_controller_init' ));
        
	  define('VTWPR_PRO_PLUGIN_NAME',                       'Wholesale Pricing Pro for WooCommerce');
    define('VTWPR_PRO_FREE_PLUGIN_NAME',                  'Wholesale Pricing for WooCommerce');
    define('VTWPR_PRO_VERSION',                           '1.0.61');
    define('VTWPR_PRO_MINIMUM_REQUIRED_FREE_VERSION',     '1.0.61');  //required version of
    define('VTWPR_PRO_LAST_UPDATE_DATE',                  '2017-10-05');     
    define('VTWPR_PRO_DIRNAME',                           ( dirname( __FILE__ ) ));
	  define('VTWPR_PRO_URL',                                plugins_url( '', __FILE__ ) );
    define('VTWPR_PRO_BASE_NAME',                          basename(VTWPR_PRO_DIRNAME));
    define('VTWPR_PRO_REMOTE_VERSION_FILE',               'http://www.varktech.com/pro/vtwpr-pro-for-woocommerce-version.txt');
    define('VTWPR_PRO_DOWNLOAD_FREE_VERSION_BY_PARENT',   'http://wordpress.org/extend/plugins/wholesale-pricing-for-woocommerce/');
    define('VTWPR_PRO_PLUGIN_SLUG',                        plugin_basename(__FILE__)); 
	  define('VTWPR_LIFETIME_LIMITS_PURCHASER',              $wpdb->prefix.'vtwpr_lifetime_limits_purchaser'); 
    define('VTWPR_LIFETIME_LIMITS_PURCHASER_RULE',         $wpdb->prefix.'vtwpr_lifetime_limits_purchaser_rule');      
    define('VTWPR_LIFETIME_LIMITS_PURCHASER_LOGID_RULE',   $wpdb->prefix.'vtwpr_lifetime_limits_purchaser_logid_rule');
	}   //end constructor

	                                                             
 /* ************************************************
 **   Overhead and Init
 *************************************************** */
	public function vtwpr_pro_controller_init(){
     if (is_admin()){
        add_action('after_plugin_row', array( &$this, 'vtwpr_pro_check_plugin_version' ));
        add_action('admin_init', array( &$this, 'vtwpr_pro_check_for_free_version' ));
        add_filter( 'plugin_action_links_' . VTWPR_PRO_PLUGIN_SLUG , array( $this, 'vtwpr_custom_action_links' ) );
     }
  }
    

	public function vtwpr_pro_activation_hook() {
  
//mwntest  
//ob_start();
	  			

	  $this->vtwpr_pro_check_for_free_version();

//mwntest     
//$contents = ob_get_contents();    
//echo '$contents= <pre>'.print_r($contents, true).'</pre>' ; 
//wp_die( __('<strong>Looks like</strong>', 'vtmin'), __('VT Minimum Purchase not compatible - WP', 'vtmin'), array('back_link' => true));  

		return;
}
	
	public function vtwpr_pro_check_for_free_version() {	
  
    global $wp_version;
	

	//***************************
	//CHECK FOR FREE VERSION
	//***************************
    $plugin = VTWPR_PRO_PLUGIN_SLUG;
    $free_plugin_download = '<a  href="' . VTWPR_PRO_DOWNLOAD_FREE_VERSION_BY_PARENT . '"  title="Download from wordpress.org"> WordPress.org </a>';
    $plugin_name = VTWPR_PRO_PLUGIN_NAME;
    $free_plugin_name = VTWPR_PRO_FREE_PLUGIN_NAME;
    
    if(!defined('VTWPR_VERSION')) { 
  			if( is_plugin_active($plugin) ) {
  			   deactivate_plugins( $plugin );
        }

        $message  =  '<strong>' . __('Please Download and/or Activate ' , 'vtwprpro') .$free_plugin_name.  __('(the Free version). ' , 'vtwprpro') . '</strong>' ;
        $message .=  '<br>' . __('It must be installed and active, before the Pro version can be activated.  The Free version can be downloaded from ' , 'vtwprpro')  . $free_plugin_download ;
        $admin_notices = '<div id="message" class="error fade" style="background-color: #FFEBE8 !important;"><p>' . $message . ' </p></div>';
        add_action( 'admin_notices', create_function( '', "echo '$admin_notices';" ) );

        return;
    }                                        
  
    $new_version =      VTWPR_PRO_MINIMUM_REQUIRED_FREE_VERSION;
    $current_version =  VTWPR_VERSION;
    if( (version_compare(strval($new_version), strval($current_version), '>') == 1) ) {   //'==1' = 2nd value is lower  
        if( is_plugin_active($plugin) ) {
  			   deactivate_plugins( $plugin );
        }
        $message  =  '<strong>' . __('Please Update ' , 'vtwprpro') .$free_plugin_name. '</strong>' ;
        $message .=  '<br>' . __('It must be current, before the Pro version can be activated.  The Free version can be downloaded from ' , 'vtwprpro')  . $free_plugin_download ;
        $message .=  '<br>' . __('The Current Free program version = ', 'vtwprpro')  .VTWPR_VERSION.  __(' , while the PRO required Free version = ', 'vtwprpro') . VTWPR_PRO_MINIMUM_REQUIRED_FREE_VERSION  ;
        
        $admin_notices = '<div id="message" class="error fade" style="background-color: #FFEBE8 !important;"><p>' . $message . ' </p></div>';
        add_action( 'admin_notices', create_function( '', "echo '$admin_notices';" ) );
        return;
    }    
  }
 
  /* ************************************************
  **   Admin - Uninstall Hook and cleanup
  *************************************************** */ 
  function vtwpr_pro_uninstall_hook() {
      if ( !defined( 'WP_UNINSTALL_PLUGIN' ) ) {
      	exit ();
      }

  }
   
    //Add Custom Links to PLUGIN page action links                     ///wp-admin/edit.php?post_type=vtmam-rule&page=vtmam_setup_options_page
  public function vtwpr_custom_action_links( $links ) {                 
		$plugin_links = array(
			'<a href="' . admin_url( 'edit.php?post_type=vtwpr-rule&page=vtwpr_setup_options_page' ) . '">' . __( 'Settings', 'vtwpr' ) . '</a>',
			'<a href="http://www.varktech.com">' . __( 'Docs', 'vtwpr' ) . '</a>'
		);
		return array_merge( $plugin_links, $links );
	}

function vtwpr_pro_check_plugin_version( $plugin ) {
  /*
    $plugin is system supplied if 
    add_action('after_plugin_row', array( &$this, 'vtwpr_pro_check_plugin_version' ));
    is used.  
    
    $plugin = 'vt-minimum-purchase-pro/vt-minimum-purchase-pro.php';
  */  
 // echo '<br>plugin name= '  .$plugin;  //mwn
  
  if( strpos( VTWPR_PRO_BASE_NAME.'/'.__FILE__,$plugin ) !== false ) {  
  
    
    $new_version = wp_remote_fopen(VTWPR_PRO_REMOTE_VERSION_FILE, 'r');
    
 //   echo '<br>External file version= ' .$new_version;  //mwn
 
    if( $new_version ) {      
      $current_version = VTWPR_PRO_VERSION;
      $installation_location = VTWPR_PRO_INSTALLATION_INSTRUCTIONS_BY_PARENT;
      if( (version_compare(strval($new_version), strval($current_version), '>') == 1) ) {   //'==1' = 2nd value is lower 
        
 //    echo '<br>new version found, current version= ' .$current_version; //mwn
    
        $update_msg = __('There is a new version of ', 'vtwpr') . VTWPR_PRO_PLUGIN_NAME . __(' available.', 'vtwpr') ;
        echo ' <td colspan="5" class="plugin-update" style="line-height:1.2em; font-size:11px; padding:1px;">
                <div style="color:#000; font-weight:bold; margin:4px; padding:6px 5px; background-color:#fffbe4; border-color:#dfdfdf; border-width:1px; border-style:solid; -moz-border-radius:5px; -khtml-border-radius:5px; -webkit-border-radius:5px; border-radius:5px;">'.  strip_tags( $update_msg ) .' <a href="'.$installation_location.'" target="_blank">View version ' . $new_version . ' for details</a>.</div	>
              </td>';
      } else {
        return;
      }
    }
  }
}
 
 
} //end class
$vtwpr_pro_controller = new VTWPR_Pro_Controller;

//has to be out here, accessing the plugin instance
if (is_admin()){
  register_activation_hook(__FILE__, array( $vtwpr_pro_controller, 'vtwpr_pro_activation_hook'));
}
